#include <stdio.h>
#include <stdlib.h>
#include "patoh.h"

int main(int argc, char *argv[])
{
PaToH_Parameters args;
int             _c, _n, _nconst, *cwghts, *nwghts, 
                *xpins, *pins, *partvec, cut, *partweights;

 if (argc!=3) {
     fprintf(stderr, "usage: %s <filename> <#parts>\n", argv[0]);
     exit(1);
 }
     
 
PaToH_Read_Hypergraph(argv[1], &_c, &_n, &_nconst, &cwghts, 
                      &nwghts, &xpins, &pins);

printf("Hypergraph %10s -- #Cells=%6d  #Nets=%6d  #Pins=%8d #Const=%2d\n",
       argv[1], _c, _n, xpins[_n], _nconst);
 
PaToH_Initialize_Parameters(&args, PATOH_CONPART, 
                            PATOH_SUGPARAM_DEFAULT);

args._k = atoi(argv[2]);
partvec =  (int *) malloc(_c*sizeof(int));
partweights  = (int *) malloc(args._k*sizeof(int));

PaToH_Alloc(&args, _c, _n, _nconst, cwghts, nwghts, 
            xpins, pins);

PaToH_Partition(&args, _c, _n, cwghts, nwghts, 
                xpins, pins, partvec, partweights, &cut);

printf("%d-way cutsize is: %d\n", args._k, cut);

free(partweights);
free(partvec);
  
PaToH_Free();
return 0;
}
